<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { ProModal } from 'antdv-pro-modal';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { ColumnsType } from 'ant-design-vue/es/table';
import { Form, Modal, message } from 'ant-design-vue/es';
import { parseDateToStr } from '@/utils/date-utils';
import {
  getBakFile,
  getBakFileList,
  downFile,
  delFile,
  updateFTPInfo,
  getFTPInfo,
  putFTPInfo,
} from '@/api/logManage/exportFile';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
import saveAs from 'file-saver';
import { regExpIPv4 } from '@/utils/regular-utils';
const { t } = useI18n();

/**网元参数 */
let logSelect = ref<string[]>([]);

/**文件列表 */
let fileList = ref<any>([]);

/**查询参数 */
let queryParams = reactive({
  /**读取路径 */
  path: '',
  /**表名 */
  tableName: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**记录数据 */
  data: object[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'small',
  data: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('views.logManage.neFile.fileMode'),
    dataIndex: 'fileMode',
    align: 'center',
    width: 150,
  },
  {
    title: t('views.logManage.neFile.owner'),
    dataIndex: 'owner',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.logManage.neFile.group'),
    dataIndex: 'group',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.logManage.neFile.size'),
    dataIndex: 'size',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.logManage.neFile.modifiedTime'),
    dataIndex: 'modifiedTime',
    align: 'left',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value * 1000);
    },
    width: 150,
  },
  {
    title: t('views.logManage.neFile.fileName'),
    dataIndex: 'fileName',
    align: 'left',
  },
  {
    title: t('common.operate'),
    key: 'fileName',
    align: 'center',
    width: 100,
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**下载触发等待 */
let downLoading = ref<boolean>(false);

/**删除触发等待 */
let delLoading = ref<boolean>(false);

/**信息文件下载 */
function fnDownloadFile(row: Record<string, any>) {
  if (downLoading.value) return;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.logManage.exportFile.downTip', {
      fileName: row.fileName,
    }),
    onOk() {
      downLoading.value = true;
      const hide = message.loading(t('common.loading'), 0);
      downFile({
        path: queryParams.path,
        fileName: row.fileName,
      })
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', {
                msg: t('common.downloadText'),
              }),
              duration: 2,
            });
            saveAs(res.data, `${row.fileName}`);
          } else {
            message.error({
              content: t('views.logManage.exportFile.downTipErr'),
              duration: 2,
            });
          }
        })
        .finally(() => {
          hide();
          downLoading.value = false;
        });
    },
  });
}

function fnRecordDelete(row: Record<string, any>) {
  if (delLoading.value) return;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.logManage.exportFile.deleteTip', {
      fileName: row.fileName,
    }),
    onOk() {
      const key = 'delFile';
      delLoading.value = true;
      message.loading({ content: t('common.loading'), key });
      delFile({
        fileName: row.fileName,
        path: queryParams.path,
      })
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('views.system.user.delSuss'),
              key,
              duration: 2,
            });
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              key: key,
              duration: 2,
            });
          }
        })
        .finally(() => {
          delLoading.value = false;
        });
    },
  });
}

/**网元类型选择对应修改 */
function fnNeChange(keys: any, opt: any) {
  queryParams.tableName = keys;
  queryParams.path = opt.path;
  fnGetList(1);
}

/**查询备份信息列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (queryParams.tableName === '') {
    message.warning({
      content: t('views.logManage.exportFile.selectTip'),
      duration: 2,
    });
    return;
  }
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  getBakFileList(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
      tablePagination.total = res.total;
      tableState.data = res.data;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    } else {
      message.error(res.msg, 3);
      tablePagination.total = 0;
      tableState.data = [];
    }
    tableState.loading = false;
  });
}

onMounted(() => {
  getBakFile().then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
      res.data.forEach((item: any) => {
        fileList.value.push({
          value: item.tableName,
          label: item.tableDisplay,
          path: item.filePath,
        });
      });
    }
  });
  // .finally(() => {
  //   fnGetList();
  // });
});

/**对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**FTP日志对象信息状态 */
let modalState: ModalStateType = reactive({
  openByEdit: false,
  title: 'FTP上报服务设置',
  from: {
    useranme: '',
    password: '',
    toIp: '',
    toPort: 22,
    protocol: 'ftp',
    dir: '',
  },
  confirmLoading: false,
});

/**FTP日志对象信息内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    toIp: [
      {
        required: true,
        pattern: regExpIPv4,
        message: 'Please enter the service login IP',
      },
    ],
    username: [
      {
        required: true,
        trigger: 'blur',
        message: 'Please enter the service login user name',
      },
    ],
    dir: [
      {
        required: true,
        trigger: 'blur',
        message: 'Please enter the service address target file directory',
      },
    ],
  })
);

/**
 * 对话框弹出显示为 新增或者修改
 * @param configId 参数编号id, 不传为新增
 */
function fnModalVisibleByEdit() {
  if (modalState.confirmLoading) return;
  const hide = message.loading(t('common.loading'), 0);
  modalState.confirmLoading = true;
  getFTPInfo().then(res => {
    modalState.confirmLoading = false;
    hide();
    if (res.code === RESULT_CODE_SUCCESS && res.data) {
      modalState.from = Object.assign(modalState.from, res.data);
      modalState.title = 'FTP Info';
      modalState.openByEdit = true;
    } else {
      message.error(res.msg, 3);
      modalState.title = 'FTP Info';
      modalState.openByEdit = true;
    }
  });
}

/**FTP对象保存 */
function fnModalOk() {
  modalStateFrom.validate().then(() => {
    modalState.confirmLoading = true;
    const from = toRaw(modalState.from);
    updateFTPInfo(from)
      .then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success(`FTP configuration saved successfully`, 3);
        } else {
          message.warning(`FTP configuration save exception`, 3);
        }
      })
      .finally(() => {
        modalState.confirmLoading = false;
      });
  });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.openByEdit = false;
  modalStateFrom.resetFields();
}

/**
 * 同步文件到FTP
 * @param row
 */
function fnSyncFileToFTP(row: Record<string, any>) {
  putFTPInfo(row.filePath, row.fileName)
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS) {
        message.success(`OK`, 3);
      } else {
        message.warning(res.msg, 3);
      }
    })
    .finally(() => {
      modalState.confirmLoading = false;
    });
}
</script>

<template>
  <PageContainer>
    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-form :model="queryParams" name="queryParams" layout="horizontal">
          <a-row :gutter="16" align="middle">
            <a-col>
              <span>{{ t('views.logManage.exportFile.fileName') }}:</span>&nbsp;
              <a-select
                v-model:value="logSelect"
                :options="fileList"
                @change="fnNeChange"
                :allow-clear="false"
                style="width: 200px"
              />
            </a-col>
            <template v-if="queryParams.path">
              <span>{{ t('views.logManage.neFile.nePath') }}:</span>&nbsp;
              <a-col>
                <a-breadcrumb>
                  <a-breadcrumb-item>
                    {{ queryParams.path }}
                  </a-breadcrumb-item>
                </a-breadcrumb>
              </a-col>
            </template>
          </a-row>
        </a-form>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>Setting</template>
            <a-button type="text" @click.prevent="fnModalVisibleByEdit()">
              <template #icon><DeliveredProcedureOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="fileName"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: 800 }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'fileName'">
            <a-space :size="8" align="center">
              <a-button
                type="link"
                :loading="downLoading"
                @click.prevent="fnSyncFileToFTP(record)"
                v-if="record.fileType === 'file'"
              >
                <template #icon><CloudServerOutlined /></template>
              </a-button>
              <a-button
                type="link"
                :loading="downLoading"
                @click.prevent="fnDownloadFile(record)"
                v-if="record.fileType === 'file'"
              >
                <template #icon><DownloadOutlined /></template>
              </a-button>
              <a-button
                type="link"
                :loading="delLoading"
                @click.prevent="fnRecordDelete(record)"
                v-if="record.fileType === 'file'"
              >
                <template #icon><DeleteOutlined /></template>
              </a-button>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <ProModal
      :drag="true"
      :width="800"
      :destroyOnClose="true"
      :keyboard="false"
      :mask-closable="false"
      :open="modalState.openByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :label-wrap="true"
      >
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Service IP"
              name="toIp"
              v-bind="modalStateFrom.validateInfos.toIp"
            >
              <a-input
                v-model:value="modalState.from.toIp"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Service Port"
              name="toPort"
              v-bind="modalStateFrom.validateInfos.toPort"
            >
              <a-input-number
                v-model:value="modalState.from.toPort"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input-number>
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="UserName"
              name="username"
              v-bind="modalStateFrom.validateInfos.username"
            >
              <a-input
                v-model:value="modalState.from.username"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Password"
              name="password"
              v-bind="modalStateFrom.validateInfos.password"
            >
              <a-input-password
                v-model:value="modalState.from.password"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input-password>
            </a-form-item>
          </a-col>
        </a-row>
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item label="Protocol" name="protocol">
              <a-select
                v-model:value="modalState.from.protocol"
                default-value="N"
                :placeholder="t('common.selectPlease')"
                :options="[
                  { value: 'ftp', label: 'FTP' },
                  { value: 'ssh', label: 'SSH' },
                ]"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Save Dir"
              name="dir"
              v-bind="modalStateFrom.validateInfos.dir"
            >
              <a-input
                v-model:value="modalState.from.dir"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </ProModal>
  </PageContainer>
</template>

<style lang="less" scoped></style>
